//  TIC  -   long value

#include <16F630.h>

#FUSES	NOWDT                 	//No Watch Dog Timer
#FUSES	INTRC_IO              	//Internal RC Osc, no CLKOUT
#FUSES	NOPROTECT             	//Code not protected from reading
#FUSES	BROWNOUT              	//Reset when brownout detected
#FUSES	MCLR                  	//Master Clear pin enabled
#FUSES	NOCPD                 	//No EE protection
#FUSES	NOPUT                 	//No Power Up Timer
#rom	0x3FF = {0x3448}// 
#use	delay(clock=4000000)

#define buf_n 9 //  
unsigned CHAR buf[buf_n];//   
/* = 
   {0b00111110	//1   // Privet
	0b00001100, //2
	0b00101000, //3
	0b01110000, //4
	0b11110001, //5
	0b11100001, //6
	0b00000001, //7
	0b00000000, //8
	0b00000000};//9
	*///  
	
#define H 8 //    
unsigned CHAR digits[h]; //    ,  .....

#byte	status = 3 // status
#bit	C=status.0 // 
#TYPE   LONG=32
#byte	TMR0=1 // 

#bit  P_1 = 0x36.7// 
#bit  P_2 = 0x35.6
#bit  P_3 = 0x34.5
#bit  P_4 = 0x33.4
#bit  P_5 = 0x32.3
#bit  P_6 = 0x31.2
#bit  P_7 = 0x30.1
#bit  P_8 = 0x2F.0// 

#bit  H_1 = 0x36.6// 
#bit  H_2 = 0x35.5
#bit  H_3 = 0x34.4
#bit  H_4 = 0x33.3
#bit  H_5 = 0x32.2
#bit  H_6 = 0x31.1
#bit  H_7 = 0x30.0
#bit  H_8 = 0x2E.7// 

int flagi=0;//       
#bit  razresh_vyvoda = flagi.0
#bit  one_millisecond = flagi.1

int i=0,k=0,j=1,z=0;// while  for
long value=0, d=0;
int schet_bitov=0;
int temp=0;

	
#int_timer0 
void RTCC_isr(void) { 
   TMR0 = TMR0 + 6; 
   one_millisecond = TRUE; 
   value++;
}
void preobraz(void)//  ,  ,   ...
{
d=value;
for(i=0; i <= 7; i++){digits[i] = 0;} 
while (d >= 10000000){d -= 10000000;++digits[0];} //  
while (d >= 1000000) {d -= 1000000; ++digits[1];} //
while (d >= 100000)  {d -= 100000;  ++digits[2];} // 
while (d >= 10000)   {d -= 10000;   ++digits[3];} // 
while (d >= 1000)    {d -= 1000;    ++digits[4];} //, 
while (d >= 100)     {d -= 100;     ++digits[5];} //
while (d >= 10)      {d -= 10;      ++digits[6];} //
								      digits[7] = d;//
}
void preobraz_2(void)//  
{i=8;
while(i>=0){i--;if(i==255)break;
		shift_left(buf,9,0);//   
		switch(digits[i]){
    				case 0:{temp=0b01111011;}break;
    				case 1:{temp=0b01100000;}break;
    				case 2:{temp=0b00110111;}break;
    				case 3:{temp=0b01110101;}break;
    				case 4:{temp=0b01101100;}break;
    				case 5:{temp=0b01011101;}break;
    				case 6:{temp=0b01011111;}break;
    				case 7:{temp=0b01110000;}break;
    				case 8:{temp=0b01111111;}break;
    				case 9:{temp=0b01111101;}break;
    					}
						for(k=0;k<=7;k++)
									{
									shift_left(&temp,1,0);
									shift_left(buf,9,C);
									}
			}
}
void lcd_out(void)//  
{
if(razresh_vyvoda==1)
	{
	preobraz();preobraz_2();
	    //P_3=1;P_5=1;// ,  2  4  
    	//      .
    		if(++z==30)//  180  
	    		{//  
		    	z=0;
		    	++j;
	    		if(j>8)j=1;
	    		}
		    		
		    		switch(j)
			    		{
						case 1:{H_8=1;}break;
						case 2:{H_7=1;}break;
						case 3:{H_6=1;}break;
						case 4:{H_5=1;}break;
						case 5:{H_4=1;}break;
						case 6:{H_3=1;}break;
						case 7:{H_2=1;}break;
						case 8:{H_1=1;}break;
						}
					
	    		 
    }
razresh_vyvoda=0;
if(++schet_bitov<73)//  
	{
	shift_left(buf,9,0);//    
	output_bit(PIN_c1,C);//    DIN
	output_bit(PIN_c2,1);// DCLK=1
	}
else 
	{
    schet_bitov=0;
	output_bit(PIN_c0,1);//LOAD=1
	razresh_vyvoda=1;
	}
output_bit(PIN_c2,0);// DCLK=0
output_bit(PIN_c0,0);//LOAD=0
}

void main(void)
{

	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4);
	setup_timer_1(T1_DISABLED);
	setup_comparator(NC_NC);
	setup_vref(FALSE);
	enable_interrupts(INT_RTCC);
	enable_interrupts(GLOBAL);
	set_tris_c (7);
	output_c(0);
while(1)
	{
	lcd_out();
	}
}